
#include "main.h"


extern SPI_HandleTypeDef hspi1;
#define	HSPI_IL9163		&hspi1


#include "IL9163.h"

#include "def.h"
#include "ansi.h"
#include "graph.h"
#include <stdio.h>
#include <string.h>
#include <stdio.h>      /* printf */
#include <stdlib.h>     /* abs */


//enum{ANSI_BLACK, ANSI_RED, ANSI_GREEN, ANSI_YELLOW, ANSI_BLUE, ANSI_MAGNETA, ANSI_CYAN, ANSI_WHITE,	ANSI_INVERSE };
const uint16_t tabKolor[16] = { 0x0000, IL9163_RED, IL9163_GREEN, IL9163_YELLOW, IL9163_BLUE, IL9163_MAGNETA, IL9163_CYAN, IL9163_WHITE };


volatile uint8_t TFT_ILI9163C_Mactrl_Data = 0; //container for the memory access control data
uint8_t TFT_ILI9163C_colorspaceData = 0;
uint8_t TFT_ILI9163C_sleep = 0;
uint8_t TFT_ILI9163C_rotation = 0;
uint16_t TFT_ILI9163C_cursor_x = 0, TFT_ILI9163C_cursor_y = 0;
uint16_t TFT_ILI9163C_width, TFT_ILI9163C_height;
uint8_t TFT_ILI9163C_dma = 1;
#if ILI9163C_GLEBIA == 16
uint16_t static TFT_ILI9163C[ _GRAMSIZE ]; // Bufor ekranu
#elif ILI9163C_GLEBIA == 4
uint8_t static TFT_ILI9163C[ _GRAMSIZE / 2 ]; // Bufor ekranu
#else
#error "Wybierz glebie kolorow"
#endif
uint8_t volatile DmaLcdBusy = 0;


extern unsigned char LenFontSpc;
extern const unsigned char Font5x7[];
extern const unsigned char lenFont5x7[];
extern const unsigned char Font16x16[];
extern const unsigned char Font16x32[];
uint16_t font_TFT_ILI9163C = 0x0507;
uint8_t fontX_TFT_ILI9163C, fontY_TFT_ILI9163C;


#if defined(__GAMMASET1)
const uint8_t pGammaSet[15] = {0x36, 0x29, 0x12, 0x22, 0x1C, 0x15, 0x42, 0xB7, 0x2F, 0x13, 0x12, 0x0A, 0x11, 0x0B, 0x06};
const uint8_t nGammaSet[15] = {0x09, 0x16, 0x2D, 0x0D, 0x13, 0x15, 0x40, 0x48, 0x53, 0x0C, 0x1D, 0x25, 0x2E, 0x34, 0x39};
#elif defined(__GAMMASET2)
const uint8_t pGammaSet[15] = {0x3F, 0x21, 0x12, 0x22, 0x1C, 0x15, 0x42, 0xB7, 0x2F, 0x13, 0x02, 0x0A, 0x01, 0x00, 0x00};
const uint8_t nGammaSet[15] = {0x09, 0x18, 0x2D, 0x0D, 0x13, 0x15, 0x40, 0x48, 0x53, 0x0C, 0x1D, 0x25, 0x2E, 0x24, 0x29};
#elif defined(__GAMMASET3)
const uint8_t pGammaSet[15] = {0x3F, 0x26, 0x23, 0x30, 0x28, 0x10, 0x55, 0xB7, 0x40, 0x19, 0x10, 0x1E, 0x02, 0x01, 0x00};
const uint8_t nGammaSet[15] = {0x09, 0x18, 0x2D, 0x0D, 0x13, 0x15, 0x40, 0x48, 0x53, 0x0C, 0x1D, 0x25, 0x2E, 0x24, 0x29};
#else
const uint8_t pGammaSet[15] = {0x3F, 0x25, 0x1C, 0x1E, 0x20, 0x12, 0x2A, 0x90, 0x24, 0x11, 0x00, 0x00, 0x00, 0x00, 0x00};
const uint8_t nGammaSet[15] = {0x20, 0x20, 0x20, 0x20, 0x05, 0x15, 0x00, 0xA7, 0x3D, 0x18, 0x25, 0x2A, 0x2B, 0x2B, 0x3A};
#endif



//================================================
void TFT_ILI9163C_SendSPI(uint8_t data ){
#if LCD_ILI9163C_SPI_TYPE==0
	HAL_SPI_Transmit( HSPI_IL9163, &data, 1, 2);
#elif LCD_ILI9163C_SPI_TYPE==1
	while ( (HARD_SPI->SR & SPI_FLAG_TXE) == RESET );   // poczekaj az bufor nadawczy bedzie gotowy
	//HARD_SPI->DR = (uint8_t)data;                      // wpisz dana do rejestru nadawczego

	//	SPI_HandleTypeDef *hspi;
	//	hspi = &hspi1;
	//	*((__IO uint8_t *)&hspi->Instance->DR) = data;		//   *((__IO uint8_t *)&hspi->Instance->DR) = (*hspi->pTxBuffPtr);

	*(volatile uint8_t*)(&(SPI1->DR)) = data;

	while ( (HARD_SPI->SR & SPI_FLAG_TXE) == RESET );   // poczekaj az bufor nadawczy bedzie gotowy
	// todo: powyzsze zakomentawac powinno byc oo
#else
#error "Brak wyboru rodzaju SPI dla LCD"
#endif
}


//------------------------------------------------
/*
__STATIC_INLINE void DWT_Delay_us(volatile uint32_t microseconds){
	uint32_t clk_cycle_start = DWT->CYCCNT;
	// Go to number of cycles for system
	microseconds *= (HAL_RCC_GetHCLKFreq() / 1000000);
	// Delay till end
	while ((DWT->CYCCNT - clk_cycle_start) < microseconds);
}


uint32_t DWT_Delay_Init(void) {
	// Disable TRC
	CoreDebug->DEMCR &= ~CoreDebug_DEMCR_TRCENA_Msk; // ~0x01000000;
	// Enable TRC
	CoreDebug->DEMCR |= CoreDebug_DEMCR_TRCENA_Msk; // 0x01000000;
	// Disable clock cycle counter
	DWT->CTRL &= ~DWT_CTRL_CYCCNTENA_Msk; //~0x00000001;
	// Enable clock cycle counter
	DWT->CTRL |= DWT_CTRL_CYCCNTENA_Msk; //0x00000001;
	// Reset the clock cycle counter value
	DWT->CYCCNT = 0;
	// 3 NO OPERATION instructions
	__NOP();	//__ASM volatile ('NOP');
	__NOP();	//__ASM volatile ('NOP');
	__NOP();	//__ASM volatile ('NOP');
	// Check if clock cycle counter has started
	if(DWT->CYCCNT)
	{
		return 0; // clock cycle counter started
	}
	else
	{
		return 1; // clock cycle counter not started
	}
}
 */


//------------------------------------------------
void TFT_ILI9163C_SpiEnable(){
	//	DWT_Delay_Init();
#if LCD_ILI9163C_SPI_TYPE==1
	HARD_SPI->CR1 |=  SPI_CR1_SPE;
	//    __HAL_SPI_ENABLE(hspi);
#endif
}


//------------------------------------------------
void TFT_ILI9163C_CsInactive() {
	HAL_GPIO_WritePin( LCD_CS_GPIO_Port, LCD_CS_Pin, GPIO_PIN_SET );    // CS=H
	DmaLcdBusy = 0;
}


//------------------------------------------------
void TFT_ILI9163C_CS_Disable(){
#if LCD_ILI9163C_SPI_TYPE==1
	while ( (HARD_SPI->SR & SPI_FLAG_BSY) == SET );   // poczekaj az bajt zostanie wyslany
#endif
	//	DWT_Delay_us( 1 );
	HAL_GPIO_WritePin( LCD_CS_GPIO_Port, LCD_CS_Pin, GPIO_PIN_SET );      // digitalWrite(_cs,HIGH);
}


//================================================
void TFT_ILI9163C_writecommand(uint8_t c){
	// CD=0; CMD
	HAL_GPIO_WritePin( LCD_A0_GPIO_Port, LCD_A0_Pin, GPIO_PIN_RESET );    // digitalWrite(_rs,LOW);
	HAL_GPIO_WritePin( LCD_CS_GPIO_Port, LCD_CS_Pin, GPIO_PIN_RESET );    // digitalWrite(_cs,LOW);
	TFT_ILI9163C_SendSPI( c );
	TFT_ILI9163C_CS_Disable();
}


void TFT_ILI9163C_writedata(uint8_t c){
	// CD=1; DATA
	HAL_GPIO_WritePin( LCD_A0_GPIO_Port, LCD_A0_Pin, GPIO_PIN_SET );    // digitalWrite(_rs,HIGH);
	HAL_GPIO_WritePin( LCD_CS_GPIO_Port, LCD_CS_Pin, GPIO_PIN_RESET );    // digitalWrite(_cs,LOW);
	TFT_ILI9163C_SendSPI( c );
	TFT_ILI9163C_CS_Disable();
}


void TFT_ILI9163C_writedata16(uint16_t d){
	// CD=1; DATA
	HAL_GPIO_WritePin( LCD_A0_GPIO_Port, LCD_A0_Pin, GPIO_PIN_SET );    // digitalWrite(_rs,HIGH);
	HAL_GPIO_WritePin( LCD_CS_GPIO_Port, LCD_CS_Pin, GPIO_PIN_RESET );    // digitalWrite(_cs,LOW);
	TFT_ILI9163C_SendSPI(d >> 8);
	TFT_ILI9163C_SendSPI(d);
	TFT_ILI9163C_CS_Disable();
}


inline void TFT_ILI9163C_SwapColor( uint16_t *color ){
	uint16_t c = *color << 8 | *color >> 8;   // zamiana mlodszy starszy bajt
	*color = c;
}


void TFT_ILI9163C_writeBuf( uint16_t x, uint16_t y, uint16_t color ) {    // Punkt w buforze w RAM
	if ( x * y >= _GRAMSIZE ) return;     // Kontrola zakresu


#if ILI9163C_GLEBIA == 16
	TFT_ILI9163C_SwapColor( &color );
#elif ILI9163C_GLEBIA == 4
	color &= 15;
#endif


	if ( TFT_ILI9163C_rotation == 3 ) {
		uint16_t a = x; x = y; y = a;
		x = _TFTHEIGHT - x;
#if ILI9163C_GLEBIA == 16 || ILI9163C_GLEBIA == 8
		TFT_ILI9163C[ _GRAMSIZE - (x + y * _TFTWIDTH) ] = color;
#elif ILI9163C_GLEBIA == 4
		uint32_t lin = _GRAMSIZE - (x + y * _TFTWIDTH);
		lin >>= 1;
		if( x & 1 ){		// piksel nieparzysty
			TFT_ILI9163C[ lin ] &= 15;
			TFT_ILI9163C[ lin ] |= color << 4;
		}
		else{ 				// parzysty
			TFT_ILI9163C[lin ] &= 0xF0;
			TFT_ILI9163C[ lin ] |= color;
		}
#else
#error "brak funkcji"
#endif
	}
	//todo: pozostale opcje (1 i  2) trzeba dopisac
	else {
#if ILI9163C_GLEBIA == 16 || ILI9163C_GLEBIA == 8
		TFT_ILI9163C[ _GRAMSIZE - (x + y * _TFTWIDTH) ] = color;
#elif ILI9163C_GLEBIA == 4
		uint32_t lin = (x + y * _TFTWIDTH);
		lin >>= 1;
		if( x & 1 ){		// piksel nieparzysty
			TFT_ILI9163C[ lin ] &= 15;
			TFT_ILI9163C[ lin ] |= color << 4;
		}
		else{ 				// parzysty
			TFT_ILI9163C[ lin ] &= 0xF0;
			TFT_ILI9163C[ lin ] |= color;
		}
#else
#error "brak funkcji"
#endif
	}
}


//  Colorspace selection:
//  0: RGB
//  1: GBR
void TFT_ILI9163C_colorSpace(uint8_t cspace) {
	if ( !cspace ) {
		TFT_ILI9163C_Mactrl_Data &= 0xF7;   // bitClear(TFT_ILI9163C_Mactrl_Data,3);
	} else {
		TFT_ILI9163C_Mactrl_Data |= 8;  // bitSet(TFT_ILI9163C_Mactrl_Data,3);
	}
}


inline uint16_t TFT_ILI9163C_Color24To565(int32_t color_) {
	return ((((color_ >> 16) & 0xFF) / 8) << 11) | ((((color_ >> 8) & 0xFF) / 4) << 5) | (((color_) &  0xFF) / 8);
}


void TFT_ILI9163C_chipInit( uint8_t mode ){
	uint8_t i;

	if( mode == 0 ){
#ifdef LCD_HARD_RST
	HAL_GPIO_WritePin( RST_LCD_GPIO_Port, RST_LCD_Pin, GPIO_PIN_SET );
	HAL_Delay( 1 );
#endif

	TFT_ILI9163C_SpiEnable();

	TFT_ILI9163C_writecommand(CMD_SWRESET);//software reset
	HAL_Delay(10);
	}

	TFT_ILI9163C_writecommand(CMD_SLPOUT);//exit sleep
	HAL_Delay(5);

	TFT_ILI9163C_writecommand(CMD_PIXFMT);//Set Color Format 16bit
	TFT_ILI9163C_writedata(0x05);
	HAL_Delay(5);

	TFT_ILI9163C_writecommand(CMD_GAMMASET);//default gamma curve 3
	TFT_ILI9163C_writedata(0x04);//0x04
	HAL_Delay(1);

	TFT_ILI9163C_writecommand(CMD_GAMRSEL);//Enable Gamma adj
	TFT_ILI9163C_writedata(0x01);
	HAL_Delay(1);

	TFT_ILI9163C_writecommand(CMD_NORML);

	TFT_ILI9163C_writecommand(CMD_DFUNCTR);
	TFT_ILI9163C_writedata(b11111111);//
	TFT_ILI9163C_writedata(b00000110);//

	TFT_ILI9163C_writecommand(CMD_PGAMMAC);//Positive Gamma Correction Setting
	for (i = 0; i < 15; i++) {
		TFT_ILI9163C_writedata(pGammaSet[i]);
	}

	TFT_ILI9163C_writecommand(CMD_NGAMMAC);//Negative Gamma Correction Setting
	for (i = 0; i < 15; i++) {
		TFT_ILI9163C_writedata(nGammaSet[i]);
	}

	TFT_ILI9163C_writecommand(CMD_FRMCTR1);//Frame Rate Control (In normal mode/Full colors)
	TFT_ILI9163C_writedata(0x08);//0x0C//0x08
	TFT_ILI9163C_writedata(0x02);//0x14//0x08
	HAL_Delay(1);

	TFT_ILI9163C_writecommand(CMD_DINVCTR);//display inversion
	TFT_ILI9163C_writedata(0x07);
	HAL_Delay(1);

	TFT_ILI9163C_writecommand(CMD_PWCTR1);//Set VRH1[4:0] & VC[2:0] for VCI1 & GVDD
	TFT_ILI9163C_writedata(0x0A);//4.30 - 0x0A
	TFT_ILI9163C_writedata(0x02);//0x05
	HAL_Delay(1);

	TFT_ILI9163C_writecommand(CMD_PWCTR2);//Set BT[2:0] for AVDD & VCL & VGH & VGL
	TFT_ILI9163C_writedata(0x02);
	HAL_Delay(1);

	TFT_ILI9163C_writecommand(CMD_VCOMCTR1);//Set VMH[6:0] & VML[6:0] for VOMH & VCOML
	TFT_ILI9163C_writedata(0x50);//0x50
	TFT_ILI9163C_writedata(99);//0x5b
	HAL_Delay(1);

	TFT_ILI9163C_writecommand(CMD_VCOMOFFS);
	TFT_ILI9163C_writedata(0);//0x40
	HAL_Delay(1);

	TFT_ILI9163C_writecommand(CMD_CLMADRS);//Set Column Address
	TFT_ILI9163C_writedata16(0x00);
	TFT_ILI9163C_writedata16(_GRAMWIDTH);

	TFT_ILI9163C_writecommand(CMD_PGEADRS);//Set Page Address
	TFT_ILI9163C_writedata16(0X00);
	TFT_ILI9163C_writedata16(_GRAMHEIGH);
	// set scroll area (thanks Masuda)
	TFT_ILI9163C_writecommand(CMD_VSCLLDEF);
	TFT_ILI9163C_writedata16(__OFFSET);
	TFT_ILI9163C_writedata16(_GRAMHEIGH - __OFFSET);
	TFT_ILI9163C_writedata16(0);

	TFT_ILI9163C_setRotation(0);
	TFT_ILI9163C_colorSpace( TFT_ILI9163C_colorspaceData );
	TFT_ILI9163C_writecommand(CMD_MADCTL);
	TFT_ILI9163C_writedata(TFT_ILI9163C_Mactrl_Data);

	TFT_ILI9163C_writecommand(CMD_DISPON);//display ON
	HAL_Delay(1);
	TFT_ILI9163C_writecommand(CMD_RAMWR);//Memory Write

	HAL_Delay(1);


	TFT_ILI9163C_fillScreen(0xFF00);    // RGB565
	DmaLcdBusy = 0;
}


void TFT_ILI9163C_setRotation(uint8_t m){
	TFT_ILI9163C_rotation = m % 4; // can't be higher than 3


	switch ( TFT_ILI9163C_rotation ) {
	case 0:
		TFT_ILI9163C_Mactrl_Data = b00000000;
		TFT_ILI9163C_width  = _TFTWIDTH;
		TFT_ILI9163C_height = _TFTHEIGHT;//-__OFFSET;
		break;
	case 1:
		TFT_ILI9163C_Mactrl_Data = b01100000;
		TFT_ILI9163C_width  = _TFTHEIGHT;//-__OFFSET;
		TFT_ILI9163C_height = _TFTWIDTH;
		break;
	case 2:
		TFT_ILI9163C_Mactrl_Data = b11000000;
		TFT_ILI9163C_width  = _TFTWIDTH;
		TFT_ILI9163C_height = _TFTHEIGHT;//-__OFFSET;
		break;
	case 3:
		TFT_ILI9163C_Mactrl_Data = b10100000;
		TFT_ILI9163C_width  = _TFTWIDTH;
		TFT_ILI9163C_height = _TFTHEIGHT;//-__OFFSET;
		break;
	}


	TFT_ILI9163C_colorSpace( TFT_ILI9163C_colorspaceData );

	TFT_ILI9163C_writecommand(CMD_MADCTL);
	TFT_ILI9163C_writedata(TFT_ILI9163C_Mactrl_Data);
}


void TFT_ILI9163C_clearScreen(uint16_t color){
	int px;


	TFT_ILI9163C_setAddr(0x00, 0x00, _GRAMWIDTH, _GRAMHEIGH); //go home
	if ( TFT_ILI9163C_dma ) {
#if ILI9163C_GLEBIA == 16
		TFT_ILI9163C_SwapColor( &color );
#endif
#if ILI9163C_GLEBIA == 16 || ILI9163C_GLEBIA == 8
		for (px = 0; px < _GRAMSIZE; px++) TFT_ILI9163C[px] = color;  // Wypelnij bufor kolorem
#elif ILI9163C_GLEBIA == 4
		//color = 2;
		for (px = 0; px < _GRAMSIZE / 2; px++) TFT_ILI9163C[px] = (color << 4) + color;  // Wypelnij bufor kolorem
		__NOP();
#else
#error "brak funkcji"
#endif
	}
	else {
#if ILI9163C_GLEBIA == 16 || ILI9163C_GLEBIA == 8
		for (px = 0; px < _GRAMSIZE; px++) TFT_ILI9163C_writedata16( color );
#elif ILI9163C_GLEBIA == 4
#else
#error "brak funkcji"
#endif
	}
}


void TFT_ILI9163C_fillScreen(uint16_t color){
	TFT_ILI9163C_clearScreen(color);
}


void TFT_ILI9163C_setAddr(uint16_t x0, uint16_t y0, uint16_t x1, uint16_t y1){
	TFT_ILI9163C_setAddrWindow(x0, y0, x1, y1);
}


void TFT_ILI9163C_setAddrWindow(uint16_t x0, uint16_t y0, uint16_t x1, uint16_t y1){
	TFT_ILI9163C_writecommand(CMD_CLMADRS); // Column
	if (TFT_ILI9163C_rotation == 0 || TFT_ILI9163C_rotation > 1) {
		TFT_ILI9163C_writedata16(x0);
		TFT_ILI9163C_writedata16(x1);
	} else {
		TFT_ILI9163C_writedata16(x0 + __OFFSET);
		TFT_ILI9163C_writedata16(x1 + __OFFSET);
	}

	TFT_ILI9163C_writecommand(CMD_PGEADRS); // Page
	if (TFT_ILI9163C_rotation == 0) {
		TFT_ILI9163C_writedata16(y0 + __OFFSET);
		TFT_ILI9163C_writedata16(y1 + __OFFSET);
	} else {
		TFT_ILI9163C_writedata16(y0);
		TFT_ILI9163C_writedata16(y1);
	}
	TFT_ILI9163C_writecommand(CMD_RAMWR); //Into RAM
}



void TFT_ILI9163C_invertDisplay(uint8_t i) {
	TFT_ILI9163C_writecommand(i ? CMD_DINVON : CMD_DINVOF);
}


void TFT_ILI9163C_idleMode(uint8_t onOff)
{
	if (onOff) {
		TFT_ILI9163C_writecommand(CMD_IDLEON);
	} else {
		TFT_ILI9163C_writecommand(CMD_IDLEOF);
	}
}


void TFT_ILI9163C_sleepMode(uint8_t mode){
	if (mode) {
		if (TFT_ILI9163C_sleep == 1) return;//already sleeping
		TFT_ILI9163C_sleep = 1;
		TFT_ILI9163C_writecommand(CMD_SLPIN);
		HAL_Delay(5);//needed
	} else {
		if (TFT_ILI9163C_sleep == 0) return; //Already awake
		TFT_ILI9163C_sleep = 0;
		TFT_ILI9163C_writecommand(CMD_SLPOUT);
		HAL_Delay(120);//needed
	}
}


void TFT_ILI9163C_defineScrollArea(uint16_t tfa, uint16_t bfa){
	tfa += __OFFSET;
	int16_t vsa = _GRAMHEIGH - tfa - bfa;
	if (vsa >= 0) {
		TFT_ILI9163C_writecommand(CMD_VSCLLDEF);
		TFT_ILI9163C_writedata16(tfa);
		TFT_ILI9163C_writedata16(vsa);
		TFT_ILI9163C_writedata16(bfa);
	}
}


void TFT_ILI9163C_scroll(uint16_t adrs){
	if (adrs <= _GRAMHEIGH) {
		TFT_ILI9163C_writecommand(CMD_VSSTADRS);
		TFT_ILI9163C_writedata16(adrs + __OFFSET);
	}
}


// Wysyla bufor z RAM do LCD przez DMA
#if ILI9163C_GLEBIA == 16
void TFT_ILI9163C_DisplayDMA() {
	//  TFT_ILI9163C_setAddrWindow( 0x00, 0x00, _GRAMWIDTH, _GRAMHEIGH ); // INFO: CLS screen ustawia pozycje 0,0
	// CD=1; DATA
	HAL_GPIO_WritePin( LCD_A0_GPIO_Port, LCD_A0_Pin, GPIO_PIN_SET );    // digitalWrite(_rs,HIGH);
	HAL_GPIO_WritePin( LCD_CS_GPIO_Port, LCD_CS_Pin, GPIO_PIN_RESET );    // digitalWrite(_cs,LOW);
	DmaLcdBusy = true;
	HAL_SPI_Transmit_DMA( HSPI_IL9163, (uint8_t*)TFT_ILI9163C, _GRAMSIZE * 2 );  // Wyslij bufor przez DMA
}
#elif ILI9163C_GLEBIA == 4
void TFT_ILI9163C_Display() {
	extern const char _auth[];
	extern const char _email[];
	const char _authORG[] = "(C)AVT, SaS";
	const char _emailORG[] = "sas@elportal.pl";
	if( strcmp( _auth, _authORG) || strcmp( _email, _emailORG) ){	// Gdy porownanie różne
		uint8_t static color;
		color++; color &= 7;
		TFT_ILI9163C_SetFont( 16, 16 );
		TFT_ILI9163C_PrintString_BP( 0, 64-16, (char*)_auth, color, 7-color );
		TFT_ILI9163C_PrintString_BP( 0, 64, (char*)_email, color, 7-color );
	}
//	const char _email[] = "sas@elportal.pl";


	TFT_ILI9163C_setAddrWindow( 0x00, 0x00, _GRAMWIDTH, _GRAMHEIGH );
	HAL_GPIO_WritePin( LCD_A0_GPIO_Port, LCD_A0_Pin, GPIO_PIN_SET );    // digitalWrite(_rs,HIGH);
	HAL_GPIO_WritePin( LCD_CS_GPIO_Port, LCD_CS_Pin, GPIO_PIN_RESET );    // digitalWrite(_cs,LOW);
	for (uint16_t px = 0; px < _GRAMSIZE / 2; px++){
		uint16_t d = TFT_ILI9163C[px];	// piksel nieparzysty
		d &= 15;
		uint16_t color = tabKolor[ d ];
		TFT_ILI9163C_SendSPI( color >> 8 );
		TFT_ILI9163C_SendSPI( color );
		d = TFT_ILI9163C[px];			// parzysty
		d >>= 4;
		color = tabKolor[ d ];
		TFT_ILI9163C_SendSPI( color >> 8 );
		TFT_ILI9163C_SendSPI( color );
	}
	TFT_ILI9163C_CS_Disable();
}
#else
#error "brak funkcji"
#endif


#if ILI9163C_GLEBIA == 16
void TFT_ILI9163C_WaitDMA(){   // Czeka na koniec transferu DMA
	while ( DmaLcdBusy ) __NOP();
}
#endif


#if ILI9163C_GLEBIA == 16
uint8_t TFT_ILI9163C_TestDMA(){
	return DmaLcdBusy;
}
#endif


void TFT_ILI9163C_startPushData(uint16_t x0, uint16_t y0, uint16_t x1, uint16_t y1){
	TFT_ILI9163C_setAddr(x0, y0, x1, y1);
}


void TFT_ILI9163C_pushData(uint16_t color){
	TFT_ILI9163C_writedata16(color);
}


void TFT_ILI9163C_pushColor(uint16_t color){
	TFT_ILI9163C_writedata16(color);
}


void TFT_ILI9163C_writeScreen24(const uint32_t *bitmap, uint16_t size){
	uint16_t color;
	uint16_t px;


	TFT_ILI9163C_writecommand(CMD_RAMWR);
	for (px = 0; px < size; px++) {
		color = TFT_ILI9163C_Color24To565(bitmap[px]);
		TFT_ILI9163C_writedata16(color);//todo:
	}
	TFT_ILI9163C_homeAddress();
}


void TFT_ILI9163C_drawRGBBitmap(int16_t x, int16_t y,  uint16_t *bitmap, int16_t w, int16_t h){
	uint16_t color;
	uint16_t px;
	uint16_t limit;

	limit = h * w;

	TFT_ILI9163C_writecommand(CMD_RAMWR);

	TFT_ILI9163C_setAddrWindow(x, y, x + w - 1, y + h - 1);
	for (px = 0; px < limit; px++)
	{
		// color = Color24To565(bitmap[px++]);
		color = *(bitmap + px);
		// color = Color24To565(color);
		TFT_ILI9163C_writedata16(color);//todo:
	}
	TFT_ILI9163C_homeAddress();
}


void TFT_ILI9163C_homeAddress(){
	if ( !TFT_ILI9163C_dma ) TFT_ILI9163C_setAddrWindow(0x00, 0x00, _GRAMWIDTH, _GRAMHEIGH);
}


void TFT_ILI9163C_setCursor(int16_t x, int16_t y){
	if ( !TFT_ILI9163C_dma ) {
		if (TFT_ILI9163C_boundaryCheck(x, y)) return;
		TFT_ILI9163C_setAddrWindow(0x00, 0x00, x, y);
	}
	TFT_ILI9163C_cursor_x = x;
	TFT_ILI9163C_cursor_y = y;
}


void TFT_ILI9163C_drawPixel(int16_t x, int16_t y, uint16_t color){
	if (TFT_ILI9163C_boundaryCheck(x, y)) return;


	if ((x < 0) || (y < 0)) return;

	if ( TFT_ILI9163C_dma ) TFT_ILI9163C_writeBuf( x, y, color );
	else {
		TFT_ILI9163C_setAddr(x, y, x + 1, y + 1);
		TFT_ILI9163C_writedata16(color);
	}
}


uint8_t TFT_ILI9163C_boundaryCheck(int16_t x, int16_t y){
	if ((x >= TFT_ILI9163C_width) || (y >= TFT_ILI9163C_height)) return true;
	return false;
}


void TFT_ILI9163C_drawFastVLine(int16_t x, int16_t y, int16_t h, uint16_t color){
	// Rudimentary clipping
	if (TFT_ILI9163C_boundaryCheck(x, y)) return;

	if (((y + h) - 1) >= TFT_ILI9163C_height) h = TFT_ILI9163C_height - y;

	if ( TFT_ILI9163C_dma ) {
		while (h-- > 0) TFT_ILI9163C_writeBuf( x, y + h, color );
	}
	else {
		TFT_ILI9163C_setAddr(x, y, x, (y + h) - 1);
		while (h-- > 0) {
			TFT_ILI9163C_writedata16(color);
		}
	}
}


void TFT_ILI9163C_drawFastHLine(int16_t x, int16_t y, int16_t w, uint16_t color)
{
	// Rudimentary clipping
	if (TFT_ILI9163C_boundaryCheck(x, y)) return;

	if (((x + w) - 1) >= TFT_ILI9163C_width)  w = TFT_ILI9163C_width - x;

	if ( TFT_ILI9163C_dma ) {
		while (w-- > 0) TFT_ILI9163C_writeBuf( x + w - 1, y, color );
	}
	else {
		TFT_ILI9163C_setAddr(x, y, (x + w) - 1, y);
		while (w-- > 0) {
			TFT_ILI9163C_writedata16(color);
		}
	}
}


void swap( int16_t *a, int16_t *b ){
	int16_t c = *a;
	*a = *b;
	*b = c;
}


void TFT_ILI9163C_drawLine(int16_t x0, int16_t y0, int16_t x1, int16_t y1, uint16_t color){
	if (y0 == y1) {
		if (x1 > x0) {
			TFT_ILI9163C_drawFastHLine(x0, y0, x1 - x0 + 1, color);
		} else if (x1 < x0) {
			TFT_ILI9163C_drawFastHLine(x1, y0, x0 - x1 + 1, color);
		} else {
			TFT_ILI9163C_drawPixel(x0, y0, color);
		}
		return;
	} else if (x0 == x1) {
		if (y1 > y0) {
			TFT_ILI9163C_drawFastVLine(x0, y0, y1 - y0 + 1, color);
		} else {
			TFT_ILI9163C_drawFastVLine(x0, y1, y0 - y1 + 1, color);
		}
		return;
	}

	uint8_t steep = abs(y1 - y0) > abs(x1 - x0);
	if (steep) {
		swap(&x0, &y0);
		swap(&x1, &y1);
	}
	if (x0 > x1) {
		swap(&x0, &x1);
		swap(&y0, &y1);
	}

	int16_t dx, dy;
	dx = x1 - x0;
	dy = abs(y1 - y0);

	int16_t err = dx / 2;
	int16_t ystep;

	if (y0 < y1) {
		ystep = 1;
	} else {
		ystep = -1;
	}

	//  SPI.beginTransaction(ILI9163C_SPI);

	int16_t xbegin = x0;
	if (steep) {
		for (; x0 <= x1; x0++) {
			err -= dy;
			if (err < 0) {
				int16_t len = x0 - xbegin;
				if (len) {
					TFT_ILI9163C_drawFastVLine(y0, xbegin, len + 1, color);
				} else {
					TFT_ILI9163C_drawPixel(y0, x0, color);
				}
				xbegin = x0 + 1;
				y0 += ystep;
				err += dx;
			}
		}
		if (x0 > xbegin + 1) {
			TFT_ILI9163C_drawFastVLine(y0, xbegin, x0 - xbegin, color);
		}

	} else {
		for (; x0 <= x1; x0++) {
			err -= dy;
			if (err < 0) {
				int16_t len = x0 - xbegin;
				if (len) {
					TFT_ILI9163C_drawFastHLine(xbegin, y0, len + 1, color);
				} else {
					TFT_ILI9163C_drawPixel(x0, y0, color);
				}
				xbegin = x0 + 1;
				y0 += ystep;
				err += dx;
			}
		}
		if (x0 > xbegin + 1) {
			TFT_ILI9163C_drawFastHLine(xbegin, y0, x0 - xbegin, color);
		}
	}
}


void TFT_ILI9163C_fillRect(int16_t x, int16_t y, int16_t w, int16_t h, uint16_t color){
	if (TFT_ILI9163C_boundaryCheck(x, y)) return;

	if (((x + w) - 1) >= TFT_ILI9163C_width)  w = TFT_ILI9163C_width  - x;
	if (((y + h) - 1) >= TFT_ILI9163C_height) h = TFT_ILI9163C_height - y;

	if ( TFT_ILI9163C_dma ) {
		for (int16_t a = 0; a < h; a++) {
			for (int16_t b = 0; b < w; b++) {
				TFT_ILI9163C_writeBuf( x + a, y + b, color );
			}
		}
	}
	else {
		TFT_ILI9163C_setAddr(x, y, (x + w) - 1, (y + h) - 1);
		for (y = h; y > 0; y--) {
			for (x = w; x > 1; x--) {
				TFT_ILI9163C_writedata16(color);
			}
			TFT_ILI9163C_writedata16(color);
		}
	}
}


// INFO: musi byc po "TFT_ILI9163C_chipInit" a "TFT_ILI9163C_chipInit" z rotation ustawionym na 0
void TFT_ILI9163C_setRotation4dma(uint8_t m) {
	TFT_ILI9163C_rotation = m % 4; // can't be higher than 3
}


//------------------------------------------------------------------//
//  Rodzaj fontu to liczba hex SZER * WYS, np 0x0507 0x0816 0x1216
//------------------------------------------------------------------//
//todo: zwracac rezultat. Jesli fonty nieobslugiwane to blad
void TFT_ILI9163C_SetFont( uint8_t x, uint8_t y ){
	font_TFT_ILI9163C = x << 8 | y;
	fontX_TFT_ILI9163C = x;
	fontY_TFT_ILI9163C = y;
}


//------------------------------------------------------------------//
uint8_t TFT_ILI9163C_GetFontSizeX(){
	return fontX_TFT_ILI9163C;
}


//------------------------------------------------------------------//
uint8_t TFT_ILI9163C_GetFontSizeY(){
	return fontY_TFT_ILI9163C;
}


//------------------------------------------------------------------//
//    Rysuje znak proporcjonalny/nieproporcjonalny (bit 0 w mode) na LCD
//    Zwraca next wolna pozycje x
//------------------------------------------------------------------//
int TFT_ILI9163C_DrawFont(int x, int y, char znak, uint16_t color, uint16_t tlo, uint8_t mode ){
	uint16_t AdrGenChar, len;


	znak = LcdWin2Lcd(znak);
	AdrGenChar = znak << 3;     // Adres wzoru znaku w generatorze


	if ( font_TFT_ILI9163C == ((16<<8) | 16) ) {
		char end = 0;
		len = 16;

		//  znak = LcdWin2Lcd(znak);
		AdrGenChar = (znak - 32) << 5;   // Adres wzoru znaku w generatorze (32 bajty na znak)

		//--- szukanie szerokosci znaku i ofsetu od prawej
		if( mode & TFT_MODE_PROP ){
			char fle = 1, fll = 1;
			for (char xx = 0; xx < 16; xx++) {
				for (uint8_t yy = 0; yy < 16; yy++) {
					uint16_t cc = Font16x16[ AdrGenChar + (yy << 1)] << 8 | Font16x16[ AdrGenChar + 1 + (yy << 1) ];
					if ( cc & (1 << xx) ) fle = 0;
					if ( cc & (1 << (16 - 1 - xx)) ) fll = 0;
				}
				if ( fle ) end = xx;
				if ( fll ) len = 16 - 1 - xx - end;
			}
			if ( znak == ' ' ) {
				len = LenFontSpc * 2.5;
				end = 0;
			}
		}

		//--- rysowanie znaku
		for (uint8_t yy = 0; yy < 16; yy++) {
			uint16_t cc = Font16x16[ AdrGenChar + (yy << 1)] << 8 | Font16x16[ AdrGenChar + 1 + (yy << 1) ];
			cc >>= end; // dosowamy w prawo
			uint16_t mask = len;
			for (uint8_t xx = 0; xx < len; xx++) {
				if ( cc & (1 << mask) ) TFT_ILI9163C_drawPixel( x + xx - 1, yy + y, color );
				else if ( mode & TFT_MODE_TXT_BACK ) TFT_ILI9163C_drawPixel( x + xx - 1, yy + y, tlo );
				mask--;
			}
		}
	}
#ifndef FONT_16x32_OFF
	else if ( font_TFT_ILI9163C == ((16<<8) | 32) ) {
		char end = 0;
		len = 16;

		//  znak = LcdWin2Lcd(znak);
		AdrGenChar = znak << 6;   // Adres wzoru znaku w generatorze (64 bajty na znak)

		//--- szukale szerokosci znaku i ofsetu od prawej
		if( mode & TFT_MODE_PROP ){
			char fle = 1, fll = 1;
			for (char xx = 0; xx < 16; xx++) {
				for (uint8_t yy = 0; yy < 32; yy++) {
					uint16_t cc = Font16x32[ AdrGenChar + (yy << 1)] << 8 | Font16x32[ AdrGenChar + 1 + (yy << 1) ];
					if ( cc & (1 << xx) ) fle = 0;
					if ( cc & (1 << (16 - 1 - xx)) ) fll = 0;
				}
				if ( fle ) end = xx;
				if ( fll ) len = 16 - 1 - xx - end;
			}
			if ( znak == ' ' ) {
				len = LenFontSpc * 2.5;
				end = 0;
			}
		}

		//--- rysowanie znaku
		for (uint8_t yy = 0; yy < 32; yy++) {
			uint16_t cc = Font16x32[ AdrGenChar + (yy << 1)] << 8 | Font16x32[ AdrGenChar + 1 + (yy << 1) ];
			cc >>= end; // dosowamy w prawo
			uint16_t mask = len;
			for (uint8_t xx = 0; xx < len; xx++) {
				if ( cc & (1 << mask) ) TFT_ILI9163C_drawPixel( x + xx - 1, yy + y, color );
				else if ( mode & TFT_MODE_TXT_BACK ) TFT_ILI9163C_drawPixel( x + xx - 1, yy + y, tlo );
				mask--;
			}
		}
	}
#endif
	else { //----- Domyslny font 5x7 proporcjonalny
		if ( znak == ' ' ) len = LenFontSpc;
		else len = lenFont5x7[ znak ] + 1;

		for (byte yy = 0; yy < 8; yy++) {
			byte c = Font5x7[ AdrGenChar + yy ];
			uint8_t mask = len - 1;
			for (uint8_t xx = 0; xx < len; xx++) {
				if ( c & (1 << mask) ) TFT_ILI9163C_drawPixel( x + xx, y + yy, color );
				else if ( mode & TFT_MODE_TXT_BACK ) TFT_ILI9163C_drawPixel( x + xx, y + yy, tlo );
				mask--;
			}
		}
		//    len++;
	}


	return ( x + len );
}


//-----------------------------------------------------------------
int TFT_ILI9163C_PrintString_(int x, int y, char *text, uint16_t color, uint16_t tlo, uint8_t mode ){
	char znak;

	while (*text)         // Wyswietl tekst z RAMu
	{
		znak = (*text);
		x = TFT_ILI9163C_DrawFont(x, y, znak, color, tlo, mode );
		text++;
	}


	return ( x );
}


//-----------------------------------------------------------------
int TFT_ILI9163C_PrintString(int x, int y, char *text, uint16_t color ){
	return TFT_ILI9163C_PrintString_( x,  y, text, color, 0, 0 );
}

//-----------------------------------------------------------------
int TFT_ILI9163C_PrintString_B(int x, int y, char *text, uint16_t color, uint16_t tlo ){		// Z kolorem tla
	return TFT_ILI9163C_PrintString_( x,  y, text, color, tlo, TFT_MODE_TXT_BACK );
}

//-----------------------------------------------------------------
int TFT_ILI9163C_PrintString_P(int x, int y, char *text, uint16_t color ){						// Proporcjonalna
	return TFT_ILI9163C_PrintString_( x,  y, text, color, 0, TFT_MODE_PROP );
}

//-----------------------------------------------------------------
int TFT_ILI9163C_PrintString_BP(int x, int y, char *text, uint16_t color, uint16_t tlo ){		// Proporcjonalna z tlem
	return TFT_ILI9163C_PrintString_( x,  y, text, color, tlo, TFT_MODE_TXT_BACK + TFT_MODE_PROP );
}

//-----------------------------------------------------------------
void TFT_ILI9163C_draw_circle_section( int x, int y, int x0, int y0, uint8_t option, uint16_t color ){
	/* upper right */
	if ( option & DRAW_UPPER_RIGHT )
	{
		TFT_ILI9163C_drawPixel( x0 + x, y0 - y, color);
		TFT_ILI9163C_drawPixel( x0 + y, y0 - x, color);
	}

	/* upper left */
	if ( option & DRAW_UPPER_LEFT )
	{
		TFT_ILI9163C_drawPixel( x0 - x, y0 - y, color);
		TFT_ILI9163C_drawPixel( x0 - y, y0 - x, color);
	}

	/* lower right */
	if ( option & DRAW_LOWER_RIGHT )
	{
		TFT_ILI9163C_drawPixel( x0 + x, y0 + y, color);
		TFT_ILI9163C_drawPixel( x0 + y, y0 + x, color);
	}

	/* lower left */
	if ( option & DRAW_LOWER_LEFT )
	{
		TFT_ILI9163C_drawPixel( x0 - x, y0 + y, color);
		TFT_ILI9163C_drawPixel( x0 - y, y0 + x, color);
	}
}


void TFT_ILI9163C_drawCircle(int x0, int y0, uint8_t rad, uint8_t option, uint16_t color ){
	int_fast16_t f;
	int_fast16_t ddF_x;
	int_fast16_t ddF_y;
	int_fast16_t x;
	int_fast16_t y;

	f = 1;
	f -= rad;
	ddF_x = 1;
	ddF_y = 0;
	ddF_y -= rad;
	ddF_y *= 2;
	x = 0;
	y = rad;

	TFT_ILI9163C_draw_circle_section( x, y, x0, y0, option, color);

	while ( x < y )	{
		if (f >= 0) {
			y--;
			ddF_y += 2;
			f += ddF_y;
		}
		x++;
		ddF_x += 2;
		f += ddF_x;

		TFT_ILI9163C_draw_circle_section( x, y, x0, y0, option, color);
	}
}


//-----------------------------------------------------------------
